
% set(0,'defaultlinelinewidth',1.5);
%
% zadani        %nacte matice
% m = matice(m);  %nacte matice
% e = zeros(3,15);  %preddefinovani vektoru soku
% e(1,1) = 1;         %  poptavkovy 1, nabidkovy 2, monetarni 3, sok v 1. obdobi,
% x=reseni(m,e); %reseni
%
% figure(1)
% %subplot(212)
% plot(x(2:end,[1 2 4]),'*-')
% legend('output','inflation','interest rate')
% title('sok')
% grid





function model
%GUI pro vyuku makroekonomickho modelovn
clear all
close all



%Main
f1h=figure('Name','Model s racionlnmi oekvnmi','NumberTitle','off',...
    'Position',[100 100 920 600],'Resize','off','MenuBar','none',...
    'Units','pixels','Visible','off');

bg = get(0,'defaultUicontrolBackgroundColor');
set(f1h,'Color',bg);

%Menu
eh1 = uimenu(f1h,'Label','Vrtit pvodn hodnoty','Callback',{@eh1_callback});

%Panels

p2h = uipanel('Parent',f1h,'Title','Graf',...
    'Position',[.32 .01 .67 .8]);


p4h = uipanel('Parent',f1h,'Title','Parametry',...
    'Position',[.01 .62 .30 .38]);
p5h = uipanel('Parent',f1h,'Title','oky',...
    'Position',[.01 .01 .30 .6]);

%Axes
imgh = axes('Parent',f1h,'Position',[.32 .77 .67 .23],'Visible','off');

equations = {'Dynamick\''{a} IS k\v{r}ivka: $y_t = \alpha y_{t-1}+\beta (i_t-E_t\pi_{t+1})+e_{yt}$',...
    'Novokeynesi\''{a}nsk\''{a} Phillipsova k\v{r}ivka: $\pi_t = \gamma E_t\pi_{t-1}+(1-\gamma)\pi_t+\delta y_t+e_{\pi t}$',...
    'Monet\''{a}rn\''{i} pravidlo: $i_t = \kappa \pi_t + \lambda y_t + e_{it}$'};

xlabel(imgh,text(0,0.6,equations,'interpreter','latex',...
    'horiz','left','vert','middle','FontSize',12));

ah = axes('Parent',p2h,'Position',[.1 .1 .8 .8]);

%Image

% syms x
% f = taylor(log(1+x));
% ezplot(ah,f)
% hold on
% title(['$' latex(f) '$'],'interpreter','latex')
% hold off

%Static Text


sth1 = uicontrol(p4h,'Style','text',...
    'String','alpha:',...
    'Position',[10 180 40 20]);

sth2 = uicontrol(p4h,'Style','text',...
    'String','beta:',...
    'Position',[10 150 40 20]);

sth3 = uicontrol(p4h,'Style','text',...
    'String','gamma:',...
    'Position',[10 120 40 20]);

sth4 = uicontrol(p4h,'Style','text',...
    'String','delta:',...
    'Position',[10 90 40 20]);

sth5 = uicontrol(p4h,'Style','text',...
    'String','lamda:',...
    'Position',[10 60 40 20]);

sth6 = uicontrol(p4h,'Style','text',...
    'String','kappa:',...
    'Position',[10 30 40 20]);

sth7 = uicontrol(p4h,'Style','text',...
    'String','z intervalu (0,1]',...
    'Position',[120 180 100 20]);

sth8 = uicontrol(p4h,'Style','text',...
    'String','zporn',...
    'Position',[120 150 100 20]);

sth9 = uicontrol(p4h,'Style','text',...
    'String','z intervalu (0,1]',...
    'Position',[120 120 100 20]);

sth10 = uicontrol(p4h,'Style','text',...
    'String','kladn',...
    'Position',[120 90 100 20]);

sth11 = uicontrol(p4h,'Style','text',...
    'String','kladn',...
    'Position',[120 60 100 20]);

sth12 = uicontrol(p4h,'Style','text',...
    'String','vt jak 1',...
    'Position',[120 30 100 20]);

sth13 = uicontrol(p5h,'Style','text',...
    'String','1. obdob',...
    'Position',[70  250  100  20]);

sth14 = uicontrol(p5h,'Style','text',...
    'String','1. obdob',...
    'Position',[70  160  100  20],'Enable','off');

sth15 = uicontrol(p5h,'Style','text',...
    'String','1. obdob',...
    'Position',[70  70  100  20],'Enable','off');

%Edit text

eth1 = uicontrol(p4h,'Style','edit',...
    'String','0.8',...
    'Position',[60 180 50 20]);

eth2 = uicontrol(p4h,'Style','edit',...
    'String','-0.6',...
    'Position',[60 150 50 20]);

eth3 = uicontrol(p4h,'Style','edit',...
    'String','0.5',...
    'Position',[60 120 50 20]);

eth4 = uicontrol(p4h,'Style','edit',...
    'String','0.3',...
    'Position',[60 90 50 20]);

eth5 = uicontrol(p4h,'Style','edit',...
    'String','0.5',...
    'Position',[60 60 50 20]);

eth6 = uicontrol(p4h,'Style','edit',...
    'String','1.5',...
    'Position',[60 30 50 20]);

%Pop-up menu
pmh1 = uicontrol('Parent',p5h,'Style','popupmenu',...
    'String',{'Poptvkov ok','Nabdkov ok','Monetrn ok'},...
    'Value',1,'Position',[70 310 160 20]);

pmh2 = uicontrol('Parent',p5h,'Style','popupmenu',...
    'String',{'Poptvkov ok','Nabdkov ok','Monetrn ok'},...
    'Value',1,'Position',[70 220 160 20],'Enable','off');

pmh3 = uicontrol('Parent',p5h,'Style','popupmenu',...
    'String',{'Poptvkov ok','Nabdkov ok','Monetrn ok'},...
    'Value',1,'Position',[70 130 160 20],'Enable','off');

%Checkbox
cbh1 = uicontrol('Parent',p5h,'Style','checkbox',...
    'String','1. ok',...
    'Value',1,'Position',[5 308 60 20],'Callback',{@callback_cbh1});

cbh2 = uicontrol('Parent',p5h,'Style','checkbox',...
    'String','2. ok',...
    'Value',0,'Position',[5 218 60 20],'Callback',{@callback_cbh2});

cbh3 = uicontrol('Parent',p5h,'Style','checkbox',...
    'String','3. ok',...
    'Value',0,'Position',[5 128 60 20],'Callback',{@callback_cbh3});

%Slider
sh1 = uicontrol('Parent',p5h,'Style','slider',...
    'Max',15,'Min',1,'Value',1,...
    'SliderStep',[1/14 1/14],...
    'Position',[5  275  225  20],'Callback',{@callback_slider});

sh2 = uicontrol('Parent',p5h,'Style','slider',...
    'Max',15,'Min',1,'Value',1,...
    'SliderStep',[1/14 1/14],...
    'Position',[5  185  225  20],'Callback',{@callback_slider2},'Enable','off');

sh3 = uicontrol('Parent',p5h,'Style','slider',...
    'Max',15,'Min',1,'Value',1,...
    'SliderStep',[1/14 1/14],...
    'Position',[5  95  225  20],'Callback',{@callback_slider3},'Enable','off');


%Push button
pbh = uicontrol('Parent',p5h,'Style','pushbutton','String','Spustit',...
    'Position',[20 5 200 60],'Callback',{@callback_button});




%Callbacks

    function callback_slider(~,~)
        set(sth13,'String',[num2str(ceil(get(sh1,'Value'))) '. obdob']);
    end

    function callback_slider2(~,~)
        set(sth14,'String',[num2str(ceil(get(sh2,'Value'))) '. obdob']);
    end

    function callback_slider3(~,~)
        set(sth15,'String',[num2str(ceil(get(sh3,'Value'))) '. obdob']);
    end

    function callback_cbh1(~,~)
        if (get(cbh1,'Value') == 1)
            set([sth13 pmh1 sh1],'Enable', 'on');
        else
            set([sth13 pmh1 sh1],'Enable', 'off');
        end
    end

    function callback_cbh2(~,~)
        if (get(cbh2,'Value') == 1)
            set([sth14 pmh2 sh2],'Enable', 'on');
        else
            set([sth14 pmh2 sh2],'Enable', 'off');
        end
    end

    function callback_cbh3(~,~)
        if (get(cbh3,'Value') == 1)
            set([sth15 pmh3 sh3],'Enable', 'on');
        else
            set([sth15 pmh3 sh3],'Enable', 'off');
        end
    end


    function eh1_callback(~,~)
        
        
        set(eth1,'String','0.8');
        set(eth2,'String','-0.6');
        set(eth3,'String','0.5');
        set(eth4,'String','0.3');
        set(eth5,'String','0.5');
        set(eth6,'String','1.5');
        
        set(pmh1,'Value',1,'Enable','on');
        set(pmh2,'Value',1,'Enable','off');
        set(pmh3,'Value',1,'Enable','off');
        
        set(sh1,'Value',1,'Enable','on');
        set(sh2,'Value',1,'Enable','off');
        set(sh3,'Value',1,'Enable','off');
        
        set(cbh1,'Value',1);
        set(cbh2,'Value',0);
        set(cbh3,'Value',0);
        
        
        set(sth13,'String',[num2str(get(sh1,'Value')) '. obdob'],'Enable','on');
        set(sth14,'String',[num2str(get(sh1,'Value')) '. obdob'],'Enable','off');
        set(sth15,'String',[num2str(get(sh1,'Value')) '. obdob'],'Enable','off');
        
    end




    function callback_button(~,~)
        
        
        
        set(0,'defaultlinelinewidth',1.5);
        
        %modelove rovnice AD ... agregatni poptavka
        %                 PC ... Phillipsova krivka
        %                 IR ... identita pro relanou urokovou miru
        %                 MR ... pravidlo monetarni politiky (taylorovo)
        
        %AD      y_t = alpha *y_t-1 + beta* (i_t - E_t pi_t+1) + e_1
        %PC     pi_t = gamma* pi_t-1 +  (1 - gamma)* E_t pi_t+1 + delta* y_t + e_2
        %MR     i_t  = lambda* y_t + kappa* E_t pi_t+1  + e_3
        
        %promene y_t ... vystup v case t  (odchylka od rovnovazne urovne - steady
        %state)
        %        r_t = i_t - E_t pi_t+1 ... realna urokova mira (odchylka od rovnovazne urovne)
        %       pi_t ... inflace
        %        i_t ... nominlani urokova mira
        %        e_1 ... sok AD
        %        e_2 ... sok PC
        %        e_3 ... sok MR
        
        %parametry
        error = '';
        
        a = strrep(get(eth1,'String'),',','.');
        if or(str2double(a)<=0, str2double(a)>1)
            error = char(error,'Zadejte parametr alpha z intervalu (0,1].');
        else
            alpha = str2double(a);     % (0,1]
        end
        
        b = strrep(get(eth2,'String'),',','.');
        if (str2double(b)>=0)
            error = char(error,'Zadejte parametr beta mensi nez 0.');
        else
            beta = str2double(b);   %zaporna
        end
        
        c = strrep(get(eth3,'String'),',','.');
        if or(str2double(c)<=0, str2double(c)>1)
            error = char(error,'Zadejte parametr gamma z intervalu (0,1].');
        else
            gamma = str2double(c);     % (0,1]
        end
        
        d = strrep(get(eth4,'String'),',','.');
        if (str2double(d)<=0)
            error =char(error,'Zadejte parametr delta vetsi nez 0.');
        else
            delta = str2double(d);     % kladna
        end
        
        l = strrep(get(eth5,'String'),',','.');
        if (str2double(l)<=0)
            error = char(error,'Zadejte parametr lambda vetsi nez 0.');
        else
            lambda = str2double(l);     % kladna
        end
        
        k = strrep(get(eth6,'String'),',','.');
        if (str2double(k)<=1)
            error = char(error,'Zadejte parametr kappa vetsi nez 1.');
        else
            kappa = str2double(k);     % vetsi nez 1
        end
        if (~isempty(error))
            warndlg(error)
        else
            
            
            
            % rovnici IR dosadime do AD za r_t, cely system prevedeme do tvaru
            % A*E_t x_t+1 = B*x_t + C*e_t
            % vektor promench  x_t = [y_t-1 pi_t-1 pi_t i_t-1 ]'
            % vektor exogennich soku e_t = [epsilon, omega, xi]'
            % 4. doplnena rovnice svazuje pi_t
            
            m.A = [1    0   beta  -beta
                -delta  1   -(1-gamma)     0
                -lambda  -kappa  0     1
                0    1     0       0  ];
            
            m.B = [  alpha   0   0   0
                0    gamma  0   0
                0     0   0   0
                0     0   1   0];
            
            m.C = [1  0  0
                0  1  0
                0  0  1
                0  0  0];
            
            m.prows=[1 2 4]; % predeterminovane radky, jejichz hodnotu v case t zname
            
            m = matice(m);  %nacte matice
            e = zeros(3,15);  %preddefinovani vektoru soku
            
            if (get(cbh1,'Value') == 1)
                e(get(pmh1,'Value'),ceil(get(sh1,'Value'))) = 1;         %  poptavkovy 1, nabidkovy 2, monetarni 3, sok v 1. obdobi,
            end
            
            if (get(cbh2,'Value') == 1)
                e(get(pmh2,'Value'),ceil(get(sh2,'Value'))) = 1;         %  poptavkovy 1, nabidkovy 2, monetarni 3, sok v 1. obdobi,
            end
            
            if (get(cbh3,'Value') == 1)
                e(get(pmh3,'Value'),ceil(get(sh3,'Value'))) = 1;         %  poptavkovy 1, nabidkovy 2, monetarni 3, sok v 1. obdobi,
            end
            
            x=reseni(m,e); %reseni
            
            plot(ah,x(1:end,[1 2 4]),'*-')
            xlim([1 15])
            legend('vstup','inflace','rokov mra')
            title('sok')
            grid
            
        end
    end



xlim([1 15])
grid

set(f1h,'Visible','on');


end