function X=reseni(m,e)

if ~m.bk
  error('Blanchard-Kahn violated. No simulation computed.');
end

[p,n]=size(m.A);  % p ... pocet rovnic, n ... pocet promennych
ns=length(m.prows);
nu= n - ns;

%e = transpose(e);
T = size(e,2);

% unstable dynamics
inV22= inv(m.V22);               %pomocna promena pro inv. matici (setri matlabu praci)
u      = zeros([nu, T]);         %nestabilni cast transformovaneho vektoru (P*x)
u(:,T) = -inV22*m.W2*e(:,T);     %vypocet posledniho clenu (jeste ovlivnenho eckem)

for k = T-1 : -1 : 1             %zpetna iterace
    u(:,k) = inV22*(u(:,k+1) - m.W2*e(:,k));
end

% stable dynamics
s = zeros([ns, T]);
P11 = m.P(m.prows, 1:ns);
P12 = m.P(m.prows, ns+1:end);

urows = setdiff(1:n, m.prows);  %vyber nepredeterminovanych radku
x1=zeros([1,n])';
x1(urows,1)=nan;

s(:,1) =  inv(P11)*(x1(m.prows) - P12*u(:,1));  % reseni stabilni casti v case t=1, respektive pro veliciny v case t-1 (y_t-1, pi_t-1, Nan, i_t-1)

for k = 2 : T                                 % postupna iterace pro cas do T
    s(:,k) = m.V11*s(:,k-1) + m.W1*e(:,k-1);
end

X = transpose(real(m.P * [s; u]));    %prevod transformovaneho vekotru [s;u] na konecne reseni

